#  [WIP] Genesis Foundation UI App Shell

This repo contains our core foundation app shell which powers our micro frontend based applications. It is based
on [Single-SPA](https://single-spa.js.org/), and can be considered the
[root config](https://single-spa.js.org/docs/configuration/) in the context of single-spa.

### [Module Federation Details](https://webpack.js.org/concepts/module-federation):

| Remote Name           | Port  |
| --------------------- | ----- |
| foundationShell       | 3010  |

### Routing

Top level routing is provided by single-spa, ie. user hits `/settings`, single-spa loads settings. Internal routing is
the concern of the app / micro frontend itself. This decouples them from single-spa for use in a traditional setup. 
Inside the "settings" app / mf for example, we'd use a generic router like
[fast-router](https://github.com/microsoft/fast/tree/master/packages/web-components/fast-router)
or [page.js](https://github.com/visionmedia/page.js). In the case of "settings" as an example, the internal routing
would omit any top level reference to `/settings/...`, and just define sub routes like `/`, `/account`, `/appearance`,
`notifications`, which bottom out at `/settings`, `/settings/account`, `/settings/appearance`,
`/settings/notifications`, to allow the host to define the top level route.

### [TBD] Layout Engine

Single-spa provides a [Layout Engine](https://single-spa.js.org/docs/layout-overview) that we *may* tap into. The layout
engine provides a routing API that controls your top level routes, applications, and dom elements. layouts can be
defined in html, json, or js that returns json. This will enable low / no code layout configuration at some point.

[![lerna](https://img.shields.io/badge/maintained%20with-lerna-cc00ff.svg)](https://lerna.js.org/)
[![TypeScript](https://img.shields.io/badge/%3C%2F%3E-TypeScript-%230074c1.svg)](https://www.typescriptlang.org/)

### Troubleshooting
- The application uses service-workers, which means views might not update as expected during the development process.
  To ensure files are updated when changed, you can configure your developer tools to update the assets on reload:
  (https://stackoverflow.com/questions/40783790/disable-service-workers-when-in-development-mode).
  You can also build and serve a production build.

## License

Note: this project provides front end dependencies and uses licensed components listed in the next section, thus licenses for those components are required during development. Contact [Genesis Global](https://genesis.global/contact-us/) for more details.