const elementLoader = `<div className="loading">Loading...</div>`;
const appLoader = `<div className="loading">Loading...</div>`;
module.exports = (authToken, loggedInUser) => ({
    mode: 'history',
    base: '/',
    containerEl: '#app',
    routes: [
        {
            type: 'nav',
            attrs: [
                {
                    name: 'class',
                    value: 'header',
                },
            ],
            routes: [
                {
                    type: 'application',
                    name: '@genesislcap/foundation-header',
                    error: "<h1>Oops! The header isn't working right now</h1>",
                    loader: elementLoader,
                },
            ],
        },
        {
            type: 'div',
            attrs: [
                {
                    name: 'class',
                    value: 'main-content',
                },
            ],
            routes: [
                {
                    type: 'route',
                    path: 'settings',
                    routes: [
                        {
                            type: 'application',
                            name: '@genesislcap/foundation-settings',
                            error: "<h1>Oops! The settings isn't working right now</h1>",
                            loader: appLoader,
                            props: {
                                authToken,
                                loggedInUser,
                            },
                        },
                    ],
                },
                {
                    type: 'route',
                    default: true,
                    routes: [
                        {
                            type: 'h1',
                            value: '404 Not Found',
                        },
                    ],
                },
            ],
        },
        {
            type: 'footer',
            routes: [
                {
                    type: 'application',
                    name: '@genesislcap/foundation-footer',
                    error: "<h1>Oops! The footer isn't working right now</h1>",
                    loader: elementLoader,
                },
            ],
        },
    ],
    redirects: {
        '/old-settings': '/settings',
    },
});
