import { registerApplication, start } from 'single-spa';
import { constructApplications, constructRoutes, constructLayoutEngine } from 'single-spa-layout';
const templateElement = document.querySelector('#foundation-shell');
const layoutData = {
    loaders: {
        element: `<div class="loading">Loading...</div>`,
        app: `<div class="loading">Loading...</div>`,
    },
    props: {
        authToken: `fds789dsfyuiosodusfd`,
        loggedInUser: ``,
    },
    errors: {
        header: `<h1>Oops! The header isn't working right now</h1>`,
        settings: `<h1>Oops! Settings isn't working right now</h1>`,
        footer: `<h1>Oops! The footer isn't working right now</h1>`,
    },
};
const routes = constructRoutes(templateElement, layoutData);
const applications = constructApplications({
    routes,
    loadApp({ name }) {
        return import(name);
    },
});
const layoutEngine = constructLayoutEngine({ routes, applications });
applications.forEach(registerApplication);
layoutEngine.activate();
start();
